@page "/Lists/Log"
@inject Microsoft.Extensions.Localization.IStringLocalizer<App> Localize
@inject DataService DS
@inject SessionData SD
@inject IJSRuntime JSRuntime
@using BioMap
@inherits ProtectedPage

<div class="box">
  <div class="row header">
    <FilterSettings FilteringTarget="@Filters.FilteringTargetEnum.Log" />
  </div>
  <div class="row content">
    <Row>
      <Column>
        <Card Margin="Margin.Is4.OnY">
          <CardHeader>
            <CardTitle>@Localize["Log"]</CardTitle>
          </CardHeader>
          <CardBody>
            <table class="table table-striped table-sm">
              <thead>
                <tr>
                  <th scope="col">@Localize["Time"]</th>
                  <th scope="col">@Localize["User"]</th>
                  <th scope="col">@Localize["Action"]</th>
                </tr>
              </thead>
              <tbody>
                @foreach (var le in LogEntries) {
                  <tr>
                    <td>@le.CreationTime.ToString("yyyy-MM-dd HH:mm:ss")</td>
                    <td>@le.User</td>
                    <td>@le.Action</td>
                  </tr>
                }
              </tbody>
            </table>
          </CardBody>
          <CardFooter>
            <Button Class="float-right small" Color="Color.Primary" Clicked="((e)=> { LoadAll=true; RefreshData(); })">@Localize["Load all"]</Button>
          </CardFooter>
        </Card>
      </Column>
    </Row>
  </div>
</div>

@code {
  private bool LoadAll = false;
  private LogEntry[] LogEntries = new LogEntry[0];
  protected override void OnInitialized() {
    base.OnInitialized();
    this.SD.Filters.FilterChanged += this.Filters_FilterChanged;
    this.RefreshData();
  }
  protected override async Task OnAfterLeavePage()
  {
    this.SD.Filters.FilterChanged -= this.Filters_FilterChanged;
  }
  private void Filters_FilterChanged(object sender, EventArgs e)
  {
    this.RefreshData();
    base.InvokeAsync(this.StateHasChanged);
  }
  private void RefreshData()
  {
    this.LogEntries = DS.GetLogEntries(SD,SD.Filters,"","log.dt DESC",(uint)(this.LoadAll ? 0 : 200));
    this.StateHasChanged();
  }
}
